/*
 * << H a r u free pdf library >> -- PdfFontDef_ZapfDingbats.cc
 *
 * Copyright (c) 1999-2003 Takeshi Kanno <takeshi_kanno@est.hi-ho.ne.jp>
 *
 * Permission to use, copy, modify, distribute and sell this software
 * and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear
 * in supporting documentation.
 * It is provided "as is" without express or implied warranty.
 *
 */


#include "libharu.h"

/*----- ZapfDingbats Font ---------------------------------------------------*/

PdfZapfDingbatsFontDef::PdfZapfDingbatsFontDef()
    : PdfType1FontDef("ZapfDingbats")
{
    const pdf_char_data_ro char_data[203] = {
        {32, "space", 278},
        {33, "a1", 974},
        {34, "a2", 961},
        {35, "a202", 974},
        {36, "a3", 980},
        {37, "a4", 719},
        {38, "a5", 789},
        {39, "a119", 790},
        {40, "a118", 791},
        {41, "a117", 690},
        {42, "a11", 960},
        {43, "a12", 939},
        {44, "a13", 549},
        {45, "a14", 855},
        {46, "a15", 911},
        {47, "a16", 933},
        {48, "a105", 911},
        {49, "a17", 945},
        {50, "a18", 974},
        {51, "a19", 755},
        {52, "a20", 846},
        {53, "a21", 762},
        {54, "a22", 761},
        {55, "a23", 571},
        {56, "a24", 677},
        {57, "a25", 763},
        {58, "a26", 760},
        {59, "a27", 759},
        {60, "a28", 754},
        {61, "a6", 494},
        {62, "a7", 552},
        {63, "a8", 537},
        {64, "a9", 577},
        {65, "a10", 692},
        {66, "a29", 786},
        {67, "a30", 788},
        {68, "a31", 788},
        {69, "a32", 790},
        {70, "a33", 793},
        {71, "a34", 794},
        {72, "a35", 816},
        {73, "a36", 823},
        {74, "a37", 789},
        {75, "a38", 841},
        {76, "a39", 823},
        {77, "a40", 833},
        {78, "a41", 816},
        {79, "a42", 831},
        {80, "a43", 923},
        {81, "a44", 744},
        {82, "a45", 723},
        {83, "a46", 749},
        {84, "a47", 790},
        {85, "a48", 792},
        {86, "a49", 695},
        {87, "a50", 776},
        {88, "a51", 768},
        {89, "a52", 792},
        {90, "a53", 759},
        {91, "a54", 707},
        {92, "a55", 708},
        {93, "a56", 682},
        {94, "a57", 701},
        {95, "a58", 826},
        {96, "a59", 815},
        {97, "a60", 789},
        {98, "a61", 789},
        {99, "a62", 707},
        {100, "a63", 687},
        {101, "a64", 696},
        {102, "a65", 689},
        {103, "a66", 786},
        {104, "a67", 787},
        {105, "a68", 713},
        {106, "a69", 791},
        {107, "a70", 785},
        {108, "a71", 791},
        {109, "a72", 873},
        {110, "a73", 761},
        {111, "a74", 762},
        {112, "a203", 762},
        {113, "a75", 759},
        {114, "a204", 759},
        {115, "a76", 892},
        {116, "a77", 892},
        {117, "a78", 788},
        {118, "a79", 784},
        {119, "a81", 438},
        {120, "a82", 138},
        {121, "a83", 277},
        {122, "a84", 415},
        {123, "a97", 392},
        {124, "a98", 392},
        {125, "a99", 668},
        {126, "a100", 668},
        {128, "a89", 390},
        {129, "a90", 390},
        {130, "a93", 317},
        {131, "a94", 317},
        {132, "a91", 276},
        {133, "a92", 276},
        {134, "a205", 509},
        {135, "a85", 509},
        {136, "a206", 410},
        {137, "a86", 410},
        {138, "a87", 234},
        {139, "a88", 234},
        {140, "a95", 334},
        {141, "a96", 334},
        {161, "a101", 732},
        {162, "a102", 544},
        {163, "a103", 544},
        {164, "a104", 910},
        {165, "a106", 667},
        {166, "a107", 760},
        {167, "a108", 760},
        {168, "a112", 776},
        {169, "a111", 595},
        {170, "a110", 694},
        {171, "a109", 626},
        {172, "a120", 788},
        {173, "a121", 788},
        {174, "a122", 788},
        {175, "a123", 788},
        {176, "a124", 788},
        {177, "a125", 788},
        {178, "a126", 788},
        {179, "a127", 788},
        {180, "a128", 788},
        {181, "a129", 788},
        {182, "a130", 788},
        {183, "a131", 788},
        {184, "a132", 788},
        {185, "a133", 788},
        {186, "a134", 788},
        {187, "a135", 788},
        {188, "a136", 788},
        {189, "a137", 788},
        {190, "a138", 788},
        {191, "a139", 788},
        {192, "a140", 788},
        {193, "a141", 788},
        {194, "a142", 788},
        {195, "a143", 788},
        {196, "a144", 788},
        {197, "a145", 788},
        {198, "a146", 788},
        {199, "a147", 788},
        {200, "a148", 788},
        {201, "a149", 788},
        {202, "a150", 788},
        {203, "a151", 788},
        {204, "a152", 788},
        {205, "a153", 788},
        {206, "a154", 788},
        {207, "a155", 788},
        {208, "a156", 788},
        {209, "a157", 788},
        {210, "a158", 788},
        {211, "a159", 788},
        {212, "a160", 894},
        {213, "a161", 838},
        {214, "a163", 1016},
        {215, "a164", 458},
        {216, "a196", 748},
        {217, "a165", 924},
        {218, "a192", 748},
        {219, "a166", 918},
        {220, "a167", 927},
        {221, "a168", 928},
        {222, "a169", 928},
        {223, "a170", 834},
        {224, "a171", 873},
        {225, "a172", 828},
        {226, "a173", 924},
        {227, "a162", 924},
        {228, "a174", 917},
        {229, "a175", 930},
        {230, "a176", 931},
        {231, "a177", 463},
        {232, "a178", 883},
        {233, "a179", 836},
        {234, "a193", 836},
        {235, "a180", 867},
        {236, "a199", 867},
        {237, "a181", 696},
        {238, "a200", 696},
        {239, "a182", 874},
        {241, "a201", 874},
        {242, "a183", 760},
        {243, "a184", 946},
        {244, "a197", 771},
        {245, "a185", 865},
        {246, "a194", 771},
        {247, "a198", 888},
        {248, "a186", 967},
        {249, "a195", 888},
        {250, "a187", 831},
        {251, "a188", 873},
        {252, "a189", 927},
        {253, "a190", 970},
        {254, "a191", 918},
        {-1, NULL, 0}
    };
    fFontBBox.left = -1;
    fFontBBox.top = -143;
    fFontBBox.right = 981;
    fFontBBox.bottom = 820;
    fAscent = 0;
    fDescent =0;
    fXHeight = 0;
    fIsBase14Font = true;
    fDefaultEncoding = PDF_FONT_SPECIFIC;
    fFirstChar = 32;
    fLastChar = 254;
    
    SetWidths(char_data);
}

/*----------------------------------------------------------------------------*/
/*------ PdfZapfDingbatsFontEncoding -----------------------------------------*/

PdfZapfDingbatsFontEncoding::PdfZapfDingbatsFontEncoding()
        : PdfEncodingDef()
{
    fFirstChar = 32;
    fLastChar = 254;
    fBaseEncoding = PDF_FONT_SPECIFIC;
}

/*----------------------------------------------------------------------------*/
